<template>
    <div class="uk-flex uk-flex-center">
        <div class="probleme-container" id="probleme-container" v-if="probleme">
            <TitreProbleme
                :typeExercice="getTitre()"
                :niveau="probleme.getNiveau()"
            />
            <Goban
                ref="goban"
                :id="probleme.getId()"
                :situationInitiale="probleme.getSituationInitiale()"
                :marqueursInitiaux="probleme.getMarqueursInitiaux()"
                :solution="probleme.getPossibilites()"
                :position="probleme.getPosition()"
                @afficherCommentaire="demanderMiseAJourCommentaire"
                @envoyerResultat="envoyerResultat"
            />
            <Actions
                :probleme="probleme"
                :isProfilProfesseur="isProfilProfesseur"
            />
            <transition name="component-fade" mode="out-in">
                <Instructions
                    ref="instructions"
                    :premierCommentaire="probleme.getCommentaire()"
                />
            </transition>
        </div>
    </div>
</template>

<script lang="ts">
import Component, { mixins } from 'vue-class-component';
import { Prop } from 'vue-property-decorator';
import Goban from './GobanTesuji.vue';
import Actions from '../commun/Actions.vue';
import TitreProbleme from '../commun/TitreProbleme.vue';
import Instructions from '../commun/Instructions.vue';
import AffichageProbleme from '../commun/AffichageProbleme.vue';
import AvecPossibilites from '@/classes/AvecPossibilites';
import UIkit from 'uikit';
import Axios from '@/auth/axiosAuth';
import ExperienceUtilisateur from '@/classes/ExperienceUtilisateur';

@Component({
    components: { Goban, Actions, TitreProbleme, Instructions },
})
export default class AffichageTesuji extends mixins(AffichageProbleme) {
    @Prop() probleme: AvecPossibilites;
    @Prop() isProfilProfesseur: boolean;

    // mounted() {
    //     const experience: ExperienceUtilisateur = this.$auth.user.getExperience();
    //     if (!experience.getTesuji()) {
    //         UIkit.modal('#' + this.getTitreModal(this.probleme)).show();
    //         Axios.post(
    //             'utilisateur/experience/tesuji/' + this.$auth.user.id,
    //             () => this.$auth.user.getExperience().setTesuji(true),
    //         );
    //     }
    // }

    public getTitre(): string {
        const titre = this.probleme.getTypeProbleme().toLowerCase();
        return titre.charAt(0).toUpperCase() + titre.slice(1);
    }

    public getCommentaireInitial(): string {
        return this.probleme.getCommentaire();
    }
}
</script>

<style>
.component-fade-enter-active,
.component-fade-leave-active {
    transition: opacity 0.3s ease;
}
.component-fade-enter,
.component-fade-leave-to {
    opacity: 0;
}
.probleme-container {
    width: 40%;
}

@media screen and (max-width: 540px) {
    .probleme-container {
        width: 80%;
    }
}
</style>
